﻿Public Class frmADS1115_ADC
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public formloading As Boolean = True
    Public I2CBasic As Boolean = False

    Private Sub Read_1_Click(sender As Object, e As EventArgs) Handles Read_1.Click
        Dim ADC As Long
        Dim I2CPort As Byte = Port.Value
        Dim Channel As Byte = 0
        Dim Resolution As Byte = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel1.Maximum = GetMax(Resolution)
        Channel1.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC1.Text = String.Format("{0,6:N0}", ADC)
        VC1.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()
    End Sub

    Private Sub Read_2_Click(sender As Object, e As EventArgs) Handles Read_2.Click
        Dim ADC As Long
        Dim I2CPort As Byte = Port.Value
        Dim Channel As Byte = 1
        Dim Resolution As Byte = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel2.Maximum = GetMax(Resolution)
        Channel2.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC2.Text = String.Format("{0,6:N0}", ADC)
        VC2.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()
    End Sub

    Private Sub Read_3_Click(sender As Object, e As EventArgs) Handles Read_3.Click
        Dim ADC As Long
        Dim I2CPort As Byte = Port.Value
        Dim Channel As Byte = 2
        Dim Resolution As Byte = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel3.Maximum = GetMax(Resolution)
        Channel3.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC3.Text = String.Format("{0,6:N0}", ADC)
        VC3.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()
    End Sub

    Private Sub Read_4_Click(sender As Object, e As EventArgs) Handles Read_4.Click
        Dim ADC As Long
        Dim I2CPort As Byte = Port.Value
        Dim Channel As Byte = 3
        Dim Resolution As Byte = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel4.Maximum = GetMax(Resolution)
        Channel4.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC4.Text = String.Format("{0,6:N0}", ADC)
        VC4.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()
    End Sub
    Private Sub frmADS1115_ADC_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If I2CBasic = True Then PortGroup.Visible = False
    End Sub
    Public Sub GetTXRXData()
        txtTransmitString.Text = NCDLib.GetLastTransmitString
        txtRecString.Text = NCDLib.GetLastReceivingString
    End Sub

    Public Function GetMax(Resolution) As Integer
        GetMax = 32767 '16-Bit Mode (Single Ended = 32768)
        Me.Refresh()
    End Function
    Public Function Interpreter(Type As String, Resolution As String, ADC As Long) As String
        Me.Refresh()
        Dim Value As Decimal
        Dim Units As String = ""
        Select Case Type
            Case "0-5V ADC" 'Gain 2x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.001220703125 + (CAL.Value / 1000000))
                If Resolution = "16-Bit Resolution" Then Value = ADC * ((2.048 / 32767) + (CAL.Value / 1000000))
                Units = "V"
            Case "0-10V ADC" 'Gain 1x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.00244140625 + (CAL.Value / 1000000))
                If Resolution = "16-Bit Resolution" Then Value = ADC * ((2.048 / 32767) + (CAL.Value / 1000000))
                Units = "V"
            Case "0-20V ADC" 'Gain 1x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.0048828125 + (CAL.Value / 1000000))
                Units = "V"
            Case "0-24V ADC" 'Gain 1x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.005859375 + (CAL.Value / 1000000))
                Units = "V"
            Case "4-20mA Inputs" 'Gain 2x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.011 / 2)   '(CAL.Value / 100000) 'Validated
                Units = "mA"
            Case "0-20mA Inputs" 'Gain 2x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.011 / 2)
                Units = "mA"
            Case "0-40mA Inputs" 'Gain 1x
                If Resolution = "12-Bit Resolution" Then Value = ADC * (0.0221 / 2)
                Units = "mA"
        End Select
        Interpreter = String.Format("{0:0.000}", Value) + Units
        Me.Refresh()
        GetTXRXData()
    End Function

    Private Sub Read_18_Click(sender As Object, e As EventArgs) Handles Read_18.Click

        Dim ADC As Long
        Dim I2CPort As Byte = Port.Value
        Dim Channel As Byte = 0
        Dim Resolution As Byte = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel1.Maximum = GetMax(Resolution)
        Channel1.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC1.Text = String.Format("{0,6:N0}", ADC)
        VC1.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()

        Channel = 1
        Resolution = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel2.Maximum = GetMax(Resolution)
        Channel2.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC2.Text = String.Format("{0,6:N0}", ADC)
        VC2.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()

        Channel = 2
        Resolution = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel3.Maximum = GetMax(Resolution)
        Channel3.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC3.Text = String.Format("{0,6:N0}", ADC)
        VC3.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()

        Channel = 3
        Resolution = Resolution1.SelectedIndex
        If I2CBasic = False Then
            ADC = NCDLib.Enterprise.Hardware.I2C.Chip.ADS1115.Read_Channel(NCDComponent1, I2CPort, Address1.Value, Channel, Gain1.SelectedIndex)
        Else
            ADC = NCDLib.I2CBasic.Chip.ADS1115.Read_Channel(NCDComponent1, Address1.Value, Channel, Gain1.SelectedIndex)
        End If
        Channel4.Maximum = GetMax(Resolution)
        Channel4.Value = NCDLib.Safe.Limit_Value(ADC, 0, GetMax(Resolution))
        RawADC4.Text = String.Format("{0,6:N0}", ADC)
        VC4.Text = Interpreter(Type1.SelectedItem, Resolution1.SelectedItem, ADC)
        GetTXRXData()

    End Sub
End Class