﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Partial Class NCDLib
    ' flag for high speed writting/reading. Be Careful, it only work with direct usb access
    Public Shared HighSpeed As Boolean = False

    Public Class I2CBasic
        Public Shared I2CError As String
        ' flag for high speed writting/reading. Be Careful, it only work with direct usb access
        Public Shared HighSpeed As Boolean = False

        Public Shared Sub SoftReset(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 188)
        End Sub
        Public Shared Sub HardReset(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 189)
        End Sub
        Public Shared Function Test2Way(ByRef ncdObj As NCDController)
            NCDLib.WriteBytesAPI(ncdObj, True, 254, 33)
            Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
            Debug.Print(Result)
            Return Result
        End Function
        Public Shared Function GetVersion(ByRef ncdObj As NCDEnterprise.NCDController)

            NCDLib.WriteBytesAPI(ncdObj, True, 254, 52, 240, 5)
            Dim SettingsSETUP As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 6)
            If SettingsSETUP IsNot Nothing Then
                'Baud.SelectedIndex = NCDLib.Safe.Limit_Value(SettingsSETUP(0), 0, 5)
                'UI.SelectedIndex = NCDLib.Safe.Limit_Value(SettingsSETUP(1), 0, 1)
                'CPUPriority.Value = NCDLib.Safe.Limit_Value(SettingsSETUP(2), 0, 255)
                If SettingsSETUP(5) > 0 Then
                    GetVersion = SettingsSETUP(5)
                    'StartupOptionsGroup.Visible = True
                    'FirmwareVersion.Text = "Release Firmware Version " + SettingsSETUP(5).ToString
                Else
                    'StartupOptionsGroup.Visible = False
                    GetVersion = 0
                End If
            End If

        End Function
        Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

            Dim TransmitCount As Integer = TXDAT.Length
            Dim aI(TransmitCount + 1) As Byte

            I2CError = ""
            aI(0) = 190                  'Byte 2
            aI(1) = Address              'Byte 3
            For i1 As Integer = 0 To TransmitCount - 1
                aI(i1 + 2) = TXDAT(i1) 'Int(txArray(i1).Text)
            Next

            NCDLib.WriteBytesAPI(ncdObj, True, aI)

            Dim HexOutput As Boolean = True

            Debug.Print("-------------- I2C Write Command:")
            For Each a In aI
                If HexOutput = False Then
                    Debug.Print(a)
                Else
                    Debug.Print(Hex(a).ToString)
                End If
            Next
            Debug.Print("-------------- END Command")

            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = ("I2C Write - Error Package:")
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If

        End Function
        Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

            Dim aI(2) As Byte

            I2CError = ""

            aI(0) = 191                  'Byte 2
            aI(1) = Address              'Byte 3
            aI(2) = RXBytes              'Byte 4
            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function
        Public Shared Function WriteRead(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer, Delay As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

            Dim TransmitCount As Integer = TXDAT.Length
            Dim aI(TransmitCount + 3) As Byte

            I2CError = ""
            ' aI(0) = 189                  'Byte 0
            ' aI(1) = I2CPort              'Byte 1
            aI(0) = 192                  'Byte 2
            aI(1) = Address              'Byte 3
            aI(2) = RXBytes              'Byte 4
            aI(3) = Delay                'Byte 5
            For i1 As Integer = 0 To TransmitCount - 1
                aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
            Next

            'Debug.Print("DUMP BEGIN")
            'For Temp As Integer = 0 To aI.Length - 1
            ' Debug.Print(aI(Temp).ToString)
            ' Next
            'Debug.Print("DUMP END")

            Dim HexOutput As Boolean = True
            Debug.Print("-------------- I2C Write Command:")
            For Temp As Integer = 0 To aI.Length - 1
                If HexOutput = False Then
                    Debug.Print(aI(Temp).ToString)
                Else
                    Debug.Print(Hex(aI(Temp)).ToString)
                End If
            Next
            Debug.Print("-------------- END Command")


            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function
        Public Shared Function Scan(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()

            Dim aI(1) As Byte

            '189 2 192 0

            I2CError = ""

            'aI(0) = 189                  'Select I2C Port Command
            'aI(1) = I2CPort              'Port Selection
            aI(0) = 193                  'Byte 0 Updated I2C Scan
            aI(1) = 0                    'Byte 1

            NCDLib.WriteBytesAPI(ncdObj, True, aI)

            '------------------------------------------------------------------------------------------
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

            If (Not (rData Is Nothing)) Then
                Debug.Print("-------------- I2C Scan Command:")
                For Each a In rData
                    Debug.Print(a)
                Next
                Debug.Print("-------------- END Command")
            End If


            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function

        Public Class Chip
            Public Class ADS1115
                Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer, Gain As Integer)
                    If Channel > 3 Then GoTo InvalidSettings
                    If Gain > 7 Then GoTo InvalidSettings

                    Dim LoConfig As Integer
                    Dim HiConfig As Integer
                    Dim BitChannel As Integer
                    Dim BitGain As Integer

                    Dim OS As Byte = 128    'Bit 8 128 = 196 + BitChannel Mux Selection
                    Dim Mux2 As Byte = 64   'Bit 7 64
                    Dim Mux1 As Byte = 32    'Bit 6 32
                    Dim Mux0 As Byte = 16    'Bit 5 16

                    Dim PGA2 As Byte = 8    'Bit 4 8
                    Dim PGA1 As Byte = 4    'Bit 3 4
                    Dim PGA0 As Byte = 2    'Bit 2 2
                    Dim Mode As Byte = 1    'Bit 1 1

                    Dim DR2 As Byte = 128     'Bit 7 128 = 131
                    Dim DR1 As Byte = 0       'Bit 6 64
                    Dim DR0 As Byte = 0       'Bit 5 32
                    Dim COMP_MODE As Byte = 0 'Bit 4 16
                    Dim COMP_POL As Byte = 0  'Bit 3 8
                    Dim COMP_LAT As Byte = 0  'Bit 2 4
                    Dim COMP_QUE1 As Byte = 2 'Bit 1 2
                    Dim COMP_QUE0 As Byte = 1 'Bit 0 1

                    'Bits 0 and 1 are Not Allocated

                    'Channel = 0 to 3            
                    If Channel = 0 Then BitChannel = (Mux2 * 1) + (Mux1 * 0) + (Mux0 * 0)
                    If Channel = 1 Then BitChannel = (Mux2 * 1) + (Mux1 * 0) + (Mux0 * 1)
                    If Channel = 2 Then BitChannel = (Mux2 * 1) + (Mux1 * 1) + (Mux0 * 0)
                    If Channel = 3 Then BitChannel = (Mux2 * 1) + (Mux1 * 1) + (Mux0 * 1)

                    'User Gain Value
                    If Gain = 0 Then BitGain = (PGA2 * 0) + (PGA1 * 0) + (PGA0 * 0)
                    If Gain = 1 Then BitGain = (PGA2 * 0) + (PGA1 * 0) + (PGA0 * 1)
                    If Gain = 2 Then BitGain = (PGA2 * 0) + (PGA1 * 1) + (PGA0 * 0)
                    If Gain = 3 Then BitGain = (PGA2 * 0) + (PGA1 * 1) + (PGA0 * 1)
                    If Gain = 4 Then BitGain = (PGA2 * 1) + (PGA1 * 0) + (PGA0 * 0)
                    If Gain = 5 Then BitGain = (PGA2 * 1) + (PGA1 * 0) + (PGA0 * 1)
                    If Gain = 6 Then BitGain = (PGA2 * 1) + (PGA1 * 1) + (PGA0 * 0)
                    If Gain = 7 Then BitGain = (PGA2 * 1) + (PGA1 * 1) + (PGA0 * 1)


                    'CRG = SD + BitChannel + PD1 + PD0

                    LoConfig = COMP_QUE0 + COMP_QUE1 + COMP_LAT + COMP_POL + COMP_MODE + DR0 + DR1 + DR2
                    HiConfig = Mode + BitGain + BitChannel + OS


                    'Debug.Print("-----------CRG----------- " + CRG.ToString)
                    'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                    'Dim result1() As Byte = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)
                    'Dim result2() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, I2CPort, Address, 2)

                    '                                                                               196    131

                    'Write to Configuration Register
                    Dim Result1() As Byte = NCDLib.I2CBasic.Write(ncdObj, Address, 1, HiConfig, LoConfig)

                    ncdObj.Sleep(100)
                    'Read Conversion Register
                    Dim Delay As Integer = 0
                    Dim Result2() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 2, Delay, &H0)

                    If Not (Result2 Is Nothing) Then
                        If (Result2.Length = 2) Then
                            Dim d As Long
                            'If (Result2(0) And 128) = 128 Then
                            '   Result2(0) = Result2(0) - 128
                            'End If
                            d = (Result2(0) * 256) + Result2(1)

                            If d > 32767 Then d = 0


                            Debug.Print(d.ToString)
                            Read_Channel = d
                            Return Read_Channel
                        End If
                    End If
                    Return -1

InvalidSettings:
                    Debug.Print("---------------------------------------------------")
                    Debug.Print("ERROR: ADS1115 Invalid Parameters")
                    If Channel > 7 Then Debug.Print("ERROR: ADS1115 Invalid Channel")
                    'If Resolution > 2 Then Debug.Print("ERROR: ADS7828 Invalid Resolution")
                    'If Gain > 3 Then Debug.Print("ERROR: ADS7828 Invalid Gain")

                End Function


            End Class
            Public Class ADS7828

                Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer)

                    If Channel > 7 Then GoTo InvalidSettings

                    Dim CRG As Integer
                    Dim BitChannel As Integer
                    '                         Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1

                    Dim SD As Byte = 128    'Bit 7
                    Dim C2 As Byte = 64     'Bit 6
                    Dim C1 As Byte = 32     'Bit 5
                    Dim C0 As Byte = 16     'Bit 4
                    Dim PD1 As Byte = 0     'Bit 3
                    Dim PD0 As Byte = 4     'Bit 2
                    'Bits 0 and 1 are Not Allocated

                    'Channel = 0 to 7                Bit 6-5
                    If Channel = 0 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 0)
                    If Channel = 1 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 0)
                    If Channel = 2 Then BitChannel = (C2 * 0) + (C1 * 0) + (C0 * 1)
                    If Channel = 3 Then BitChannel = (C2 * 1) + (C1 * 0) + (C0 * 1)
                    If Channel = 4 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 0)
                    If Channel = 5 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 0)
                    If Channel = 6 Then BitChannel = (C2 * 0) + (C1 * 1) + (C0 * 1)
                    If Channel = 7 Then BitChannel = (C2 * 1) + (C1 * 1) + (C0 * 1)


                    CRG = SD + BitChannel + PD1 + PD0

                    'Debug.Print("-----------CRG----------- " + CRG.ToString)
                    'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                    'Dim result1() As Byte = NCDLib.Enterprise.Hardware.I2C.Write(ncdObj, I2CPort, Address, CRG)
                    'Dim result2() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, I2CPort, Address, 2)

                    Dim Result2() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 2, 0, CRG)

                    If Not (Result2 Is Nothing) Then
                        If (Result2.Length = 2) Then
                            Dim d As Long
                            d = (Result2(0) * 256) + Result2(1)
                            Debug.Print(d.ToString)
                            Read_Channel = d
                            Return Read_Channel
                        End If
                    End If
                    Return -1

InvalidSettings:
                    Debug.Print("---------------------------------------------------")
                    Debug.Print("ERROR: ADS7828 Invalid Parameters")
                    If Channel > 7 Then Debug.Print("ERROR: ADS7828 Invalid Channel")
                    'If Resolution > 2 Then Debug.Print("ERROR: ADS7828 Invalid Resolution")
                    'If Gain > 3 Then Debug.Print("ERROR: ADS7828 Invalid Gain")
                    Debug.Print("---------------------------------------------------")

                End Function

            End Class

            Public Class PCA9685
                Public Shared Sub Setup(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Frequency As Integer)
                    Dim Result As Byte()
                    Result = NCDLib.I2CBasic.Write(ncdObj, Address, &H0, &H0)
                    Result = NCDLib.I2CBasic.Write(ncdObj, Address, &H0, &H10)
                    Result = NCDLib.I2CBasic.Write(ncdObj, Address, &HFE, &H5)
                    Result = NCDLib.I2CBasic.Write(ncdObj, Address, &H0, &H0)
                    Result = NCDLib.I2CBasic.Write(ncdObj, Address, &H0, 161)
                End Sub
                Public Shared Function SetChannel(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer, Value As Integer)
                    Dim Result As Byte()
                    If Channel = 1 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 6, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 2 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 10, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 3 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 14, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 4 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 18, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                    If Channel = 5 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 22, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 6 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 26, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 7 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 30, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 8 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 34, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                    If Channel = 9 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 38, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 10 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 42, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 11 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 46, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 12 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 50, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                    If Channel = 13 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 54, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 14 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 58, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 15 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 62, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))
                    If Channel = 16 Then Result = NCDLib.I2CBasic.Write(ncdObj, Address, 66, 0, 0, NCDLib.Math.GetLSB(Value), NCDLib.Math.GetMSB(Value))

                    Return Result
                End Function
            End Class

            Public Class MCP3428
                Public Shared Sub SetChannelResolutionGain(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                    If Channel > 3 Then GoTo InvalidSettings
                    If Resolution > 2 Then GoTo InvalidSettings
                    If Gain > 3 Then GoTo InvalidSettings

                    Dim CRG As Integer
                    Dim BitChannel As Integer
                    Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                    Dim BitResolution As Integer
                    Dim BitGain As Integer

                    'Channel = 0 to 3                Bit 6-5
                    If Channel = 0 Then BitChannel = 0
                    If Channel = 1 Then BitChannel = 32
                    If Channel = 2 Then BitChannel = 64
                    If Channel = 3 Then BitChannel = 96

                    'Resolution = 0 to 2  Bit 3-2
                    If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                    If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                    If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                    'Gain = 0 to 3        Bit 1-0
                    If Gain = 0 Then BitGain = 0    'x1 Gain
                    If Gain = 1 Then BitGain = 1    'x2 Gain
                    If Gain = 2 Then BitGain = 2    'x4 Gain
                    If Gain = 3 Then BitGain = 3    'x8 Gain
                    '0 + 8 + 1 + 16
                    CRG = BitChannel + BitConversion + BitResolution + BitGain

                    'Debug.Print("-----------CRG----------- " + Channel.ToString)
                    'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))


                    NCDLib.I2CBasic.Write(ncdObj, Address, CRG)


                    Exit Sub

InvalidSettings:
                    Debug.Print("---------------------------------------------------")
                    Debug.Print("ERROR: MCP3428 Invalid Parameters")
                    If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                    If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                    If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                    Debug.Print("---------------------------------------------------")
                End Sub

                '  Public Shared Sub Setup_Channel(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                '
                '      NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, I2CPort, Address, Channel, Resolution, Gain)
                '
                '  End Sub

                ' Public Shared Function Read_Channel_OLD(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)
                '
                '
                '     NCDLib.Enterprise.Hardware.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, Port, Address, Channel, Resolution, Gain)
                '
                '     'Wait for I2C Chip to Finish ADC Conversion
                '     If Resolution = 2 Then
                '         ncdObj.Sleep(66) ' Delay 1/15th Second
                '     End If
                '
                '     Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.Read(ncdObj, Port, Address, 2)
                '
                '     If Not (result Is Nothing) Then
                '         If (result.Length = 3) Then
                '             Dim d As Long
                '
                '             'Debug.Print("---------Resolution---" + Resolution.ToString)
                '
                '             If Resolution = 0 Then
                '                 'Debug.Print("12-Bit Resolution")
                '                 d = (result(1) And &HF) * 256 + result(2) '(result(1) * 256 + result(2))
                '             Else
                '                 ' Debug.Print("High Resolution")
                '                 d = (result(1) * 256) + result(2) '(result(1) * 256 + result(2))
                '             End If
                '             Debug.Print(d.ToString)
                '             Read_Channel_OLD = d
                '             Return Read_Channel_OLD
                '         End If
                '     End If
                '     Return -1
                '
                ' End Function

                Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                    If Channel > 3 Then GoTo InvalidSettings
                    If Resolution > 2 Then GoTo InvalidSettings
                    If Gain > 3 Then GoTo InvalidSettings

                    Dim CRG As Integer
                    Dim BitChannel As Integer
                    Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                    Dim BitResolution As Integer
                    Dim BitGain As Integer

                    'Channel = 0 to 3                Bit 6-5
                    If Channel = 0 Then BitChannel = 0
                    If Channel = 1 Then BitChannel = 32
                    If Channel = 2 Then BitChannel = 64
                    If Channel = 3 Then BitChannel = 96

                    'Resolution = 0 to 2  Bit 3-2
                    If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                    If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                    If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                    'Gain = 0 to 3        Bit 1-0
                    If Gain = 0 Then BitGain = 0    'x1 Gain
                    If Gain = 1 Then BitGain = 1    'x2 Gain
                    If Gain = 2 Then BitGain = 2    'x4 Gain
                    If Gain = 3 Then BitGain = 3    'x8 Gain
                    '0 + 8 + 1 + 16
                    CRG = BitChannel + BitConversion + BitResolution + BitGain

                    'Debug.Print("-----------CRG----------- " + Channel.ToString)
                    'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                    ' Dim result() As Byte = NCDLib.Enterprise.Hardware.I2C.WriteRead(ncdObj, Address, 2, 22, CRG)
                    Dim result() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 2, 22, CRG)

                    If Not (result Is Nothing) Then
                        If (result.Length = 2) Then
                            Dim d As Long
                            If Resolution = 0 Then
                                'Debug.Print("12-Bit Resolution")
                                d = (result(0) And &HF) * 256 + result(1) '(result(1) * 256 + result(2))
                            Else
                                ' Debug.Print("High Resolution")
                                d = (result(0) * 256) + result(1) '(result(1) * 256 + result(2))
                            End If
                            Debug.Print(d.ToString)
                            Read_Channel = d
                            Return Read_Channel
                        End If
                    End If
                    Return -1

InvalidSettings:
                    Debug.Print("---------------------------------------------------")
                    Debug.Print("ERROR: MCP3428 Invalid Parameters")
                    If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                    If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                    If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                    Debug.Print("---------------------------------------------------")

                End Function

            End Class
            Public Class MCP23008
                Public Shared Sub GPIO_PullUp(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Enabled As Boolean)
                    NCDLib.I2CBasic.Write(ncdObj, Address, &H6, Enabled)
                End Sub
                Public Shared Sub GPIO_SetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, GPIODirection As Integer)
                    NCDLib.I2CBasic.Write(ncdObj, Address, &H0, GPIODirection)
                End Sub
                Public Shared Function GPIO_GetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte
                    GPIO_GetDirection = 255
                    Dim result() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, &H0, 0)
                    If result.Length = 1 Then
                        GPIO_GetDirection = result(0)
                    End If
                End Function
                Public Shared Sub GPIO_Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, PortA As Integer)
                    NCDLib.I2CBasic.Write(ncdObj, Address, &H9, PortA)
                End Sub
                Public Shared Function GPIO_Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte()
                    Dim rData2 As Byte() = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 1, 0, &H9)
                    Return rData2
                End Function
            End Class
            Public Class MCP23017
                Public Class PortA
                    Public Shared Sub GPIO_PullUp(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Enabled As Boolean)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &HC, Enabled)
                    End Sub
                    Public Shared Sub GPIO_SetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, GPIODirection As Integer)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &H0, GPIODirection)
                    End Sub
                    Public Shared Function GPIO_GetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte
                        GPIO_GetDirection = 255
                        Dim result() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, &H0, 0)
                        If result.Length = 1 Then
                            GPIO_GetDirection = result(0)
                        End If
                    End Function
                    Public Shared Sub GPIO_Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, PortA As Integer)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &H12, PortA)
                    End Sub
                    Public Shared Function GPIO_Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte()
                        Dim rData2 As Byte() = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 1, 0, &H12)
                        Return rData2
                    End Function
                End Class
                Public Class PortB
                    Public Shared Sub GPIO_PullUp(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Enabled As Boolean)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &HD, Enabled)
                    End Sub
                    Public Shared Sub GPIO_SetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, GPIODirection As Integer)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &H1, GPIODirection)
                    End Sub
                    Public Shared Function GPIO_GetDirection(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte
                        GPIO_GetDirection = 255
                        Dim result() As Byte = NCDLib.I2CBasic.WriteRead(ncdObj, Address, &H1, 0)
                        If result.Length = 1 Then
                            GPIO_GetDirection = result(0)
                        End If
                    End Function
                    Public Shared Sub GPIO_Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, PortB As Integer)
                        NCDLib.I2CBasic.Write(ncdObj, Address, &H13, PortB)
                    End Sub
                    Public Shared Function GPIO_Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer) As Byte()
                        Dim rData2 As Byte() = NCDLib.I2CBasic.WriteRead(ncdObj, Address, 1, 0, &H13)
                        Return rData2
                    End Function
                End Class
            End Class
            Public Class AS1115
                Public Shared Sub DisplayBrightness(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Brightness As Integer)
                    NCDLib.I2CBasic.Write(ncdObj, Address, &HA, Brightness)
                End Sub
                Public Shared Sub DisplayValue(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    Dim VString As String = "000"
                    Dim CH1 As Integer = 0
                    Dim CH2 As Integer = 0
                    Dim CH3 As Integer = 0
                    'Convert Value to 3 Digit String
                    VString = Value.ToString
                    If Len(VString) = 1 Then
                        VString = "00" + Value.ToString
                    Else
                        If Len(VString) = 2 Then
                            VString = "0" + Value.ToString
                        End If
                    End If
                    'Extract Each Digit and Send to Display as 3 Bytes (Left to Right)
                    CH1 = Mid(VString, 1, 1) 'Left Digit
                    CH2 = Mid(VString, 2, 1) 'Center Digit
                    CH3 = Mid(VString, 3, 1) 'Right Digit
                    NCDLib.I2CBasic.Write(ncdObj, Address, &H1, CH1, CH2, CH3)
                End Sub
            End Class
            Public Class PCA8574_Display
                Public Shared DisplayByte As Byte
                Public Shared Sub BacklightOn(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    'Backlight = Bit 3 (Value = 8)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 1)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteByte(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub BacklightOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    'Backlight = Bit 3 (Value = 8)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 3, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteByte(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub DisplayOffCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H8)
                End Sub
                Public Shared Sub DisplayOnCursorUnderline(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HE)
                End Sub
                Public Shared Sub DisplayOnCursorOff(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HC)
                End Sub
                Public Shared Sub DisplayOnCursorBlock(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HF)
                End Sub
                Public Shared Sub DisplayShiftLeft(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H18)
                End Sub
                Public Shared Sub DisplayShiftRight(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H1C)
                End Sub
                Public Shared Sub CursorLeft(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H10)
                End Sub
                Public Shared Sub CursorRight(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H14)
                End Sub
                Public Shared Sub ClearDisplay(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H1)
                End Sub
                Public Shared Sub HomeCursor(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H2)
                End Sub
                Public Shared Sub Line1_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H80)
                End Sub
                Public Shared Sub Line2_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HC0)
                End Sub
                Public Shared Sub Line3_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &H94)
                End Sub
                Public Shared Sub Line4_20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteCommand(ncdObj, Address, &HD4)
                End Sub
                Public Shared Sub Text(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, DisplayText As String, Limit As Integer)
                    Dim Letter As Integer
                    If DisplayText IsNot Nothing Then
                        For Count = 1 To NCDLib.Safe.Limit_Value(Len(DisplayText), 1, Limit)
                            Letter = Asc(Mid(DisplayText, Count, 1))
                            Debug.Print(Count.ToString + " " + Letter.ToString)
                            NCDLib.I2CBasic.Chip.PCA8574_Display.WriteData(ncdObj, Address, Letter)
                        Next
                    End If
                End Sub
                Public Shared Sub Initialize20x4(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer)
                    DisplayByte = 2
                    'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.BacklightOn(ncdObj, Address)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 3)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 2)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 2)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 8)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 8)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 1)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 6)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 0)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, 15)
                End Sub

                Public Shared Sub WriteCommand(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, Address, Value)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, Value)
                End Sub

                Public Shared Sub WriteData(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 1) 'RS Line = High (Data Mode)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteUpperNibble(ncdObj, Address, Value)
                    NCDLib.I2CBasic.Chip.PCA8574_Display.WriteLowerNibble(ncdObj, Address, Value)
                End Sub
                Public Shared Sub WriteLowerNibble(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    'DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                    'This Bit is Reserved for the Backlight Control Line
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 0)) 'D0
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 1)) 'D1
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 2)) 'D2
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 3)) 'D3
                    '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                End Sub
                Public Shared Sub WriteUpperNibble(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    ' DisplayByte = NCDLib.Math.SetBit(DisplayByte, 0, 0) 'RS Line = Low (Command Mode)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 1, 0) 'RW Line = Low
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 1) 'E  Line = High
                    'This Bit is Reserved for the Backlight Control Line
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 4, NCDLib.Math.GetBit(Value, 4)) 'D4
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 5, NCDLib.Math.GetBit(Value, 5)) 'D5
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 6, NCDLib.Math.GetBit(Value, 6)) 'D6
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 7, NCDLib.Math.GetBit(Value, 7)) 'D7
                    '   NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    '   DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = High
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                    DisplayByte = NCDLib.Math.SetBit(DisplayByte, 2, 0) 'E  Line = Low
                    NCDLib.I2CBasic.Write(ncdObj, Address, DisplayByte)
                End Sub


                Public Shared Sub WriteByte(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Value As Integer)
                    Debug.Print(NCDLib.Math.DecToBinaryStringStandard(Value))
                    NCDLib.I2CBasic.Write(ncdObj, Address, Value)
                End Sub
            End Class
            Public Class TCA9546
                Public Shared Sub ChannelSelect(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer)
                    'Default Address of PCA9546 is &H70
                    Select Case Channel
                        Case 1 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 1)
                        Case 2 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 2)
                        Case 3 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 4)
                        Case 4 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 8)
                    End Select
                End Sub
            End Class
            Public Class PCA9547
                Public Shared Sub ChannelSelect(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, Channel As Integer)
                    'Default Address of PCA7547 is &H70
                    Select Case Channel
                        Case 1 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 8)
                        Case 2 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 9)
                        Case 3 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 10)
                        Case 4 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 11)
                        Case 5 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 12)
                        Case 6 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 13)
                        Case 7 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 14)
                        Case 8 : NCDLib.I2CBasic.Write(ncdObj, &H70 + Address, 15)
                    End Select
                End Sub
            End Class
        End Class
    End Class
End Class
