﻿Public Class frmType23_Thermocouple_2C
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type23 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type23
    Private Sub frmType23_Thermocouple_2C_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 23 Thermocouple Temperature Sensor - Address: " + SensorAddress
        Timer1.Interval = 3000
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            Celsius1.Text = Type23.Celsius1
            Fahrenheit1.Text = Type23.Fahrenheit1

            Celsius2.Text = Type23.Celsius2
            Fahrenheit2.Text = Type23.Fahrenheit2

        End If

    End Sub

    Private Sub frmfrmType12_Thermocouple_3C_Load(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub
End Class