﻿Public Class frmType28_CurrentMonitor_3C

    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public SensorAddress As String
    Public Shared DataFrame As New NCDLib.Wireless.S3B_API.SensorData
    Public Shared Type28 As New NCDLib.Wireless.S3B_API.SensorData.TypeData.Type28

    Private Sub frmType28_CurrentMonitor_3C(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.Text = "Type 28 3-Channel Current Measurement Sensor - Address: " + SensorAddress

        Timer1.Interval = 3000
        Timer1.Start()
    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        'Receive Data from Wireless Sensor
        DataFrame = NCDLib.Wireless.S3B_API.SensorDataCapture(NCDComponent1, SensorAddress)

        'Parse Data
        If (DataFrame.Valid) Then
            Waiting.Visible = False
            BatteryLevel.Value = DataFrame.BatteryInt   'Show Battery Progress Bar
            Battery.Text = DataFrame.Battery            'Show Battery Voltage in Text Box
            NODEID.Text = DataFrame.NodeID              'Show Device Node ID Data
            Address.Text = SensorAddress                'Show Sensor Address
            Counter.Text = DataFrame.Counter.ToString   'Show Transmission Cycle Counter
            SensorType.Text = DataFrame.SensorType.ToString 'Show Sensor Type
            SensorInfo.Text = DataFrame.Description     'Show Sensor Description
            Firmware.Text = DataFrame.Firmware          'Show Firmware Version
            Summary.Text = DataFrame.SensorReadings     'Show a Summary View of All Sensor Data

            CompleteFrame.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompleteFrame)
            CompletePayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.CompletePayload)
            SensorPayload.Text = NCDLib.Math.ConvertBytesToHexArrayString(DataFrame.SensorPayload)

            Amps.Text = Type28.Amps.ToString
            Milliamps.Text = Type28.Milliamps.ToString
            Amps2.Text = Type28.Amps2.ToString
            Milliamps2.Text = Type28.Milliamps2.ToString
            Amps3.Text = Type28.Amps3.ToString
            Milliamps3.Text = Type28.Milliamps3.ToString

        End If
    End Sub
    Private Sub frmType28_CurrentMonitor_3C_Timer(sender As Object, e As EventArgs) Handles MyBase.Closed

        Timer1.Stop()

    End Sub

    Private Sub GroupBox1_Enter(sender As Object, e As EventArgs) Handles GroupBox1.Enter

    End Sub
End Class